# Nexus VDI

## Introduction

**Nexus VDI** is a VDI (Virtual Desktop Infrastructure) written from scratch in Go and based on Linux/KVM + QEMU.

## Components

Nexus VDI is divided into three components:

**[nexus-server](docs/server.md)**
- Documentation about the inner workings of nexus-server [is described here](docs/server.md)
- The server program (backend) that runs on a server
- Exposes a REST API to manage users, VMs and templates

**[nexus-client](docs/client.md)**
- Documentation on how to use nexus clients [is described here](docs/client.md) 
- The client or end-user program to manage users, VMs and templates
- The client uses REST messages to communicate with **nexus-server**
- The client can be run from anywhere (locally or remotely) as long as it can communicate with **nexus-server**
- Three clients have been developed so far:
  - **nexush**
    - interactive command line client, similar to a shell
    - currently, the most user-friendly way to interact with **nexus-server**
    - not suited to scripting or automated operations
  - **nexus-cli**
    - provides the same features and commands syntax as nexush
    - by opposition to nexush, it is well suited to scripting and automated operations
  - **nexus-exam**
    - basic graphical application used by students during live exams to connect to their running VMs
- Clients need the `remote-viewer` third party application in order to view and interact with VMs' desktops
  - `remote-viewer` is part of the [virt-viewer project](https://gitlab.com/virt-viewer/virt-viewer.git)


## Build and installation

[This documentation describes](docs/install.md) instructions on how to:

- build, install and run nexus-server for development and production
- build and run nexus clients 
- build and deploy nexus live exam OS on USB keys
